SystemOrganization addCategory: #'Xpf-Multipoint-Plugin'!

Object subclass: #MultiPointer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Plugin'!

!MultiPointer class methodsFor: 'as yet unclassified' stamp: 'SR 4/22/2009 14:30'!
getPointerCount

	<primitive: 'primitiveMultiPointerCount' module: 'MultiPointerPlugin'>
	^ 42! !

!MultiPointer class methodsFor: 'as yet unclassified' stamp: 'SR 4/22/2009 14:32'!
getPointerCurrentX: aPointerID

	<primitive: 'primitiveMultiPointerGetCurrentX' module: 'MultiPointerPlugin'>
	^ 42! !

!MultiPointer class methodsFor: 'as yet unclassified' stamp: 'SR 4/22/2009 14:32'!
getPointerCurrentY: aPointerID

	<primitive: 'primitiveMultiPointerGetCurrentY' module: 'MultiPointerPlugin'>
	^ 42! !

!MultiPointer class methodsFor: 'as yet unclassified' stamp: 'mig 4/22/2009 17:34'!
getPointerName: aPointerID

	| pointerName |
	pointerName := self pvtGetPointerName: aPointerID.
	^ pointerName truncateTo: (pointerName 
			indexOf: (Character value: 0) 
			startingAt: 0 
			ifAbsent: [pointerName size + 1]) - 1! !

!MultiPointer class methodsFor: 'as yet unclassified' stamp: 'mig 4/22/2009 16:56'!
pvtGetPointerName: aPointerID

	<primitive: 'primitiveMultiPointerName' module: 'MultiPointerPlugin'>
	^ 'Pointing Device'! !

SmartSyntaxInterpreterPlugin subclass: #MultiPointerPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Plugin'!

!MultiPointerPlugin class methodsFor: 'translation' stamp: 'SR 4/22/2009 14:07'!
hasHeaderFile
	"If there is a single intrinsic header file to be associated with the plugin, here is where you want to flag"
	^ true! !

!MultiPointerPlugin class methodsFor: 'translation' stamp: 'SR 4/22/2009 14:08'!
requiresPlatformFiles
	"this plugin requires platform specific files in order to work"
	^ true! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'SR 4/22/2009 14:28'!
initialiseModule
	"Initialise the module"
	self export: true.
	^self cCode: 'multiPointerInit()' inSmalltalk:[true]! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'SR 4/22/2009 13:23'!
moduleUnloaded: aModuleName 
	"The module with the given name was just unloaded. 
	Make sure we have no dangling references."
	self export: true.! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/22/2009 14:28'!
primitiveMultiPointerCount

	| r |
	self primitive: 'primitiveMultiPointerCount'.
	r := self cCode:' multiPointerCount()'.
	^r asOop: SmallInteger! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/23/2009 11:08'!
primitiveMultiPointerCurrentPoint: aPointerID

	| oop result inputX inputY |
	self primitive:'primitiveMultiPointerCurrentPoint'.
	self var: 'inputX' declareC: 'int inputX'.
	self var: 'inputY' declareC: 'int inputY'.
	result := (self cCode: 'multiPointerCurrentPoint(interpreterProxy->integerValueOf(aPointerID), &inputX, &inputY)') asOop: SmallInteger.
	oop := interpreterProxy instantiateClass: interpreterProxy classPoint indexableSize: 0.
	interpreterProxy storeInteger: 0 ofObject: oop withValue: inputX.
	interpreterProxy storeInteger: 1 ofObject: oop withValue: inputY.
	^ oop! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'mig 4/22/2009 16:55'!
primitiveMultiPointerName: aPointerID

	| oop length buffer realLength |
	self primitive:'primitiveMultiPointerName'.
	length := self multiPointerNameLength:  (interpreterProxy integerValueOf: aPointerID).
	oop := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: length.
	buffer :=  interpreterProxy firstIndexableField: oop.
	realLength := (self cCode: 'multiPointerName(interpreterProxy->integerValueOf(aPointerID), interpreterProxy->integerValueOf(length), buffer)') asOop: SmallInteger.
	^ oop! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'SR 4/22/2009 14:28'!
shutdownModule
	"Initialise the module"
	self export: true.
	^self cCode: 'multiPointerShutdown()' inSmalltalk:[true]! !
